#!/usr/bin/perl
#

use lib '../lib';
require 'util.pl';
require 'jcode.pl';
use Socket;

$Title = 'Completed';
$CharSet = 'EUC';
$Encoding = 'euc';

*data = parseInput($Encoding);
$data{abst} =~ s/\n/ /g;
$data{bikou} =~ s/\n/ /g;

#$pass = MakePassword(8);
$pass = &MakePassword(8,1,0,1);
#$pass = '12345678';
$s = $data{tyubunrui};
$s =~ tr/.//d;
$data{submit_time} = $data{submit_time};
$id = $data{submit_time};


if (&check_data) 
 {&error_HTML('This data is already submitted')}
else
{
  &write_data;
  &sendmail;
  &normal_HTML;
}  ;

exit(0);


#========================================================
# ¿ϿΥå
#========================================================
sub check_data {
	open(FH,"<koen.dat") or
		exitError("ե $file cannot be open");
	flock(FH,1);
	$chck = 0 ;
	while (defined($line=<FH>)) {
		@splited = split(/\|/, $line) ;
		if ( $splited[0] eq $data{submit_time} ) {$chck = 1};
#		print $line;
#		print "<BR>";
	}
	flock(FH,8);
	close(FH);
	return $chck;
}



#========================================================
# ᡼
#========================================================
sub sendmail {
$mailto='/usr/lib/sendmail';
#$myaddress= $data{mail} ;
$myaddress= $data{mail} . ',hattori@gic.kyushu-u.ac.jp,office@yuki-tohronkai.jp';
#$myaddress= $data{mail} . ',office@yuki-tohronkai.jp';
$subj= '[Japan OLED Forum]Sumittion is completed: Acceptance No.:'.$data{submit_time};
jcode::convert(\$subj, 'jis');    
$repl= '"Japan OLED Forum"<office@yuki-tohronkai.jp>';

#$tmp_name = "";
#@a_tmp_name = split(/\*/, $data{name});
#for (my $i = 0; $i < 6; $i++){
#	$i1 = $i+1;
#	if ($a_tmp_name[$i] ne ''){
#		$tmp_name .= "(*".$i1.")".$a_tmp_name[$i]."\n";
#	}
#}
#$tmp_syozoku = "";
#@a_tmp_syozoku = split(/,/, $data{syozoku});
#for (my $i = 0; $i < 6; $i++){
#	$i1 = $i+1;
#	if ($a_tmp_syozoku[$i] ne ''){
#		$tmp_syozoku .= "(*".$i1.")".$a_tmp_syozoku[$i]."\n";
#	}
#}

$message=<<END_OF_MESSAGE;
Biannual meeting of Japan OLED Forum
We've accepted your submittion as follows;
If you want to Confirm/delete your submittion or upload your 2-page abstract, 
please visit ./member/login_en.cgi
(Acceptance No. and Password in this page are needed at login.)
If you have a question, mail to $repl.


<b>Acceptance No.     </b>$data{submit_time}
Password           $pass
Research field     $data{tyubunrui}
Presentation title $data{subject}
Presenter name     $data{name}
Affiliation        $data{syozoku}
Abstract           $data{abst}
Award requirement  $data{syourei}
Short oral         $data{poster}
Contacting name    $data{daihyo}
E-mail address     $data{mail}
Remarks            $data{bikou}

END_OF_MESSAGE

&jcode'convert(*message,'jis');
&jcode'convert(*repl,'jis');

open MAIL, "|$mailto $myaddress" or die "failed mailing\n" ;
print MAIL "From: $repl\n"; 
print MAIL "To: $data{mail}\n"; 
print MAIL "Subject: $subj\n";
print MAIL "Content-Transfer-Encoding: 7bit\n";
print MAIL "Content-Type: text/plain\; charset=\"ISO-2022-JP\"\n";
print MAIL "\n\n";
print MAIL $message;
close MAIL ;
}



#================================================================
# ǡ¸
#================================================================
sub write_data {
my $d = "|";

open(FH,">>koen.dat");
flock(FH,2);
seek(FH, 0, 2);           # եݥ󥿤˥å
print FH "$data{submit_time}$d";
print FH "$pass$d";
print FH "$data{tyubunrui}$d";
print FH "$data{subject}$d";
print FH "$data{name}$d";
print FH "$data{syozoku}$d";
print FH "$data{abst}$d";
print FH "$data{syourei}$d";
print FH "$data{poster}$d";
print FH "$data{daihyo}$d";
print FH "$data{mail}$d";
print FH "$data{bikou}\n";
flock(FH,8);
close (FH);
}

sub normal_HTML {
print qq(Content-type: text/html;charset=EUC-JP\n\n);
print qq(<HTML>\n);
print qq(<HEAD>\n);
print qq(<META HTTP-EQUIV="Content-Type" CONTENT="text/html\; charset=EUC-JP">\n);
print qq(<TITLE>$Title</TITLE>\n);
print qq(</HEAD>\n);
print qq(<BODY BGCOLOR=#A3F1FF>);
print qq(<BODY>\n);
print qq(<H1>Submittion completed</H1>\n);
print qq(<H2>This submission can be comfirmed or delete at <A HREF=\"./member/login_en.cgi\">[Comfirm/Delete]</A>.</H2>\n);
print qq(<H2>If you want to modify it, please delete it and resubmit.</H2>\n);
print qq(<H2>Don't use the back bottum in your browzer to modify. It will be duplicated</H2>\n);
print qq(<H2>Please remember the acceptance No. and the password in this page for the case when the return mail cannot be sent.</H2>\n);
print "<p>Acceptance No.:$data{submit_time}";
print "<p>Password      :$pass";
print "<p>";
print "<A HREF=\"http://www.yuki-tohronkai.jp/en\">Return to Home page</A><P>";
#print qq($message\n);
#print qq($myaddress\n);
print qq(</BODY>\n);
print qq(</HTML>\n);
}

sub error_HTML {
print "Content-type: text/html;charset=EUC-JP\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print '<META HTTP-EQUIV="Content-Type" Content="text/html:charset=EUC-JP">';
print "<TITLE>Error</TITLE>\n";
print "</HEAD>\n";
print "<BODY BGCOLOR=\"#a59974\">\n";
print "<H1>@_</H1>\n";
print "<HR>\n";
print "<FONT SIZE=+1>\n";
print "</FONT>\n";
print "<P>\n";
print "<FONT SIZE=+1>\n";
print "Return to the first page\n";
print "</FONT>\n";
print "<P>\n";
print "</BODY>\n</HTML>";
}

sub MakePassword {

#Ʊ䤹ʸϾʤƤ(0O1Il)
$alpham='ABCDEFGHJKLMNPQRSTUVWXYZ';
$alphas='abcdefghijkmnopqrstuvwxyz';
$number='23456789';

#@optname=('','ѻʸ','ѻʸ');
#@optselect=('Ȥʤ','Ȥ','ɬȤ');
#ϥǡ
#use CGI;
#$form=CGI->new();
#$plen=$form->param("plen");
#$opt[0]=$form->param("opt0");
#$opt[1]=$form->param("opt1");
#$opt[2]=$form->param("opt2");

local($plen, $opt[0], $opt[1], $opt[2]) = @_;

for($i=0;$i<3;$i++){
	if($opt[$i] eq ''){$opt[$i]=1;}
}
if($plen eq ''){$plen=8;}
if($plen<4){$plen=4;}
if($plen>20){$plen=20;}

$pwseed='';
if($opt[0]>0){$pwseed="$pwseed$number";}
if($opt[1]>0){$pwseed="$pwseed$alpham";}
if($opt[2]>0){$pwseed="$pwseed$alphas";}
$len0=length($pwseed);
$len1=length($alpham);
$len2=length($alpham);
$len3=length($number);
for($i=0;$i<$plen;$i++){
	$flg[$i]=-1;
}
for($i=0;$i<3;$i++){
	if($opt[$i]==2){
		$w=rand($plen);
		$flg[$w]=$i;
	}
}
$pwd='';
for($i=0;$i<$plen;$i++){
	if($flg[$i]==0){
		$st=rand($len3);
		$wk=substr($number,$st,1);
	}
	elsif($flg[$i]==1){
		$st=rand($len1);
		$wk=substr($pwseed,$st,1);
	}
	elsif($flg[$i]==2){
		$st=rand($len2);
		$wk=substr($pwseed,$st,1);
	}
	else{
		$st=rand($len0);
		$wk=substr($pwseed,$st,1);
	}
	$pwd="$pwd$wk";
}

return $pwd; }
